diff --git a/doc/guix.texi b/doc/guix.texi
index 66ab384..f35a9fe 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -6452,11 +6452,12 @@ Usually, you will want to specify the default locale for the machine
 using the @code{locale} field of the @code{operating-system} declaration
 (@pxref{operating-system Reference, @code{locale}}).
 
-That locale must be among the @dfn{locale definitions} that are known to
-the system---and these are specified in the @code{locale-definitions}
-slot of @code{operating-system}.  The default value includes locale
-definitions for some widely used locales, but not for all the available
-locales, in order to save space.
+The selected locale is automatically added to the @dfn{locale
+definitions} known to the system.  Additional locale definitions can be
+specified in the @code{locale-definitions} slot of
+@code{operating-system}.  The default value includes locale definitions
+for some widely used locales, but not for all the available locales, in
+order to save space.
 
 If the locale specified in the @code{locale} field is not among the
 definitions listed in @code{locale-definitions}, @command{guix system}
diff --git a/gnu/system.scm b/gnu/system.scm
index d4759a0..324d071 100644
--- a/gnu/system.scm
+++ b/gnu/system.scm
@@ -669,14 +669,25 @@ hardware-related operations as necessary when booting a Linux container."
   "Return the directory containing the locales compiled for the definitions
 listed in OS.  The C library expects to find it under
 /run/current-system/locale."
-  ;; While we're at it, check whether the locale of OS is defined.
-  (unless (member (operating-system-locale os)
-                  (map locale-definition-name
-                       (operating-system-locale-definitions os)))
-    (raise (condition
-            (&message (message "system locale lacks a definition")))))
+  (define name
+    (operating-system-locale os))
 
-  (locale-directory (operating-system-locale-definitions os)
+  (define definitions
+    ;; While we're at it, check whether the locale of OS is defined.
+    (if (member (operating-system-locale os)
+                (map locale-definition-name
+                     (operating-system-locale-definitions os)))
+        (operating-system-locale-definitions os)
+        (cons (match (locale-name->definition name)
+                (#f
+                 (raise (condition
+                         (&message
+                          (message (format #f (_ "~a: invalid locale name")
+                                           name))))))
+                (def def))
+              (operating-system-locale-definitions os))))
+
+  (locale-directory definitions
                     #:libcs (operating-system-locale-libcs os)))
 
 (define (kernel->grub-label kernel)
diff --git a/gnu/system/locale.scm b/gnu/system/locale.scm
index e798827..9d695b3 100644
--- a/gnu/system/locale.scm
+++ b/gnu/system/locale.scm
@@ -1,5 +1,5 @@
 ;;; GNU Guix --- Functional package management for GNU
-;;; Copyright © 2014, 2015 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2014, 2015, 2016 Ludovic Courtès <ludo@gnu.org>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -33,6 +33,7 @@
             locale-definition-source
             locale-definition-charset
 
+            locale-name->definition
             locale-directory
 
             %default-locale-libcs
@@ -52,6 +53,22 @@
   (charset locale-definition-charset              ;string--e.g., "UTF-8"
            (default "UTF-8")))
 
+(define %not-dot
+  (char-set-complement (char-set #\.)))
+
+(define (locale-name->definition name)
+  "Return a <locale-definition> corresponding to NAME, guessing the charset,
+or #f on failure."
+  (match (string-tokenize name %not-dot)
+    ((source charset)
+     (locale-definition (name name)
+                        (source source)
+                        (charset (if (string-ci=? charset "utf8")
+                                     "UTF-8"
+                                     charset))))
+    (_
+     #f)))
+
 (define* (localedef-command locale
                             #:key (libc (canonical-package glibc)))
   "Return a gexp that runs 'localedef' from LIBC to build LOCALE."
